#!/usr/bin/env python
#
# BEGIN_COPYRIGHT
#
# Copyright (C) 2008-2019 SciDB, Inc.
# All Rights Reserved.
#
# This file is part of the Paradigm4 Enterprise SciDB distribution kit
# and may only be used with a valid Paradigm4 contract and in accord
# with the terms and conditions specified by that contract.
#
# END_COPYRIGHT
#

#Become postgres user and
#Edit /etc/postgresql/8.4/main/pg_hba.conf
#Append the following configuration lines to give access to 10.X.Y.Z/N network:
#host all all 10.X.Y.Z/N md5
# For example: 10.0.20.0/24
#
#Edit /etc/postgresql/8.4/main/postgresql.conf
#Set IP address(es) to listen on; you can use comma-separated list of addresses;
#defaults to 'localhost', and '*' is all ip address:
#listen_addresses='*'

import sys
import os
import re

OS=sys.argv[1]
username=sys.argv[2]
password=sys.argv[3]
network=sys.argv[4]

default=[
r'(local\s+all\s+all\s+)peer(.*)$',
r'(host\s+all\s+all\s+127\.0\.0\.1/32\s+)\S+(.*)$',
r'(host\s+all\s+all\s+\:\:1/128\s+)\S+(.*)$'
]
if OS in ['CentOS 6', 'CentOS 7', 'RedHat 6', 'RedHat 7']:
    pg_hba_conf="/var/lib/pgsql/9.3/data/pg_hba.conf"
    postgresql_conf="/var/lib/pgsql/9.3/data/postgresql.conf"
elif OS == "Ubuntu 14.04":
    pg_hba_conf="/etc/postgresql/9.3/main/pg_hba.conf"
    postgresql_conf="/etc/postgresql/9.3/main/postgresql.conf"
else:
    sys.stderr.write("Does not support %s\n" % OS)
    sys.exit(1)

results = []
with open(pg_hba_conf) as F:
    for line in F:
        line = line.rstrip()
        for pattern in default:
            m = re.search(pattern, line)
            if m:
                line = m.group(1) + 'trust' + m.group(2)
        results.append(line)
results.append('host    all    all    %s    md5' % network)
results.append('')

with open(pg_hba_conf, 'w') as W:
    W.write('\n'.join(results))

actual=open(postgresql_conf, 'r').readlines()
extra="listen_addresses='*'\n"
if actual[-1] != extra:
    actual.append(extra)
    open(postgresql_conf,'w').write(''.join(actual))
